% PROGRAM TO ASCERTAIN STABILITY OF CUMPUTED EQUILIBRIA
% Load the output from ps_cont
clear all
name_to_load='branch_7pi16'; fun=@funp; jacob=@jfunp;


% FontSize for plots
FntS=18;

name_to_save=strcat([name_to_load,'_stab']);
load(name_to_load)

% Output arrays: Eigs for eigenvalues
%                npos for number of positive eigenvalues
Eigs=zeros(size(Ues)); nPos=zeros(size(Lambdas));

% main cicle
disp('Computing eigenvalues of values in array Ues')
disp('Pleas wait ...')
disp(' ')
for n=1:length(Lambdas)
    u=Ues(:,n); params(jpar)=Lambdas(n);
    J=jacob(u,params);
    e=eig(J); Eigs(:,n)=e; nPos(n)=length(find(real(e)>0));
end
% Ploting results
I0=find(nPos==0); I1=find(nPos>0);
figure(2); clf; plot(Lambdas(),nUes(),'.','MarkerSize',8); hold on
                plot(Lambdas(I1),nUes(I1),'r.','MarkerSize',8)
                I2=find(nPos==2); 
                plot(Lambdas(I2),nUes(I2),'g.','MarkerSize',8)
                I3=find(nPos==3);
                plot(Lambdas(I3),nUes(I3),'y.','MarkerSize',8)
                title('Stable equilibria in blue','FontSize',FntS);
                set(gca,'FontSize',14); xlabel('\lambda','FontSize',FntS)
                 ylabel('||u||','FontSize',FntS)

figure(3); subplot(2,1,1); plot(nPos); xlabel('n','FontSize',FntS);
           title('no. of postive eigenvalues','FontSize',FntS);
           set(gca,'FontSize',12);
           subplot(2,1,2); plot(Lambdas); xlabel('n','FontSize',FntS);
           title('\lambda','FontSize',FntS); set(gca,'FontSize',12);
disp(' ... done')
clear fun; clear jacob;
save(name_to_save)
disp(strcat(['Results saved on file',blanks(3),name_to_save,'.mat']))
