function f=funp(u,params)
% FUNP returns the force acting on the top node
%            in the truss arc, for xy coordinates u,
%            dimensionles load lambda=params(1)
%            and natural bar-length mu=params(2);

lambda=params(1); mu=params(2);
% Coordinate vectors in e1 and e2
e1=[1; 0]; e2=[0; 1]; 
y1=u+e1; y2=u-e1; d1=norm(y1); d2=norm(y2);
r=( y1/d1 + y2/d2);
f=-lambda*e2 -2*u + mu*r;

