% PROGRAM TO LOCATE A BIFURCATION POINT BY SECANT METHOD APPLIED
% TO EIGENVALUE OF SMALLEST REAL PART.

%  CHANGE name_to_load name_to_save and n0 below.

clear all
name_to_load='branch_7pi16_stab'; fun=@funp; jacob=@jfunp
name_to_save_bif='branch_7pi16_bif2';
load(name_to_load)
%Index of points which there is a bifurcation point in between
n0=7; n1=n0+1;
%n0=55; n1=n0+1;


u0=Ues(:,n0); lambda0=Lambdas(n0); 
u1=Ues(:,n1); lambda1=Lambdas(n1);

% Variable for secant method; x=lambda, but could be some other.
x0=Lambdas(n0); x1=Lambdas(n1); 
t=zeros(size(t)); t(length(t))=1; % tangent to variable for secant method
params(jpar)=lambda0; J=jacob(u0,params); e=eig(J);
[me,ie]=min(abs(real(e))); f0=real(e(ie));
params(jpar)=lambda1; J=jacob(u1,params); e=eig(J);
[me,ie]=min(abs(real(e))); f1=real(e(ie));
if f0*f1>0;
    error('WOOPS! NO BIF POINT BETWEEN SELECTED PONTS. CHECK n0');
end
% DATA FOR THE SECANT METHOD
TOL=10*eps; % Tolerance raised since high precision is unlikely.
maxit=12;   % max. iter for Newton method raised since difficulties
            %      are to be expected.
TOLsec=100*TOL; maxitersec=50; % TOL and max. iter for secant method

% fictious error for secant method so that at least one iteration is done
errorsec=2*(TOLsec*norm([u0;lambda0]) + TOLsec); itersec=0;

disp('Applying Secant method to locate bif. point. Please wait ...')
disp(' ')
while errorsec>TOLsec*norm([u0;lambda0]) + TOLsec && ...
                      itersec< maxitersec
    itersec=itersec+1;
    h=-f1*((x1-x0)/(f1-f0));
    errorsec=abs(h);
    utemp=u1+h*t(1:m); lambdatemp=lambda1+h*t(m+1);  
    params(jpar)=lambdatemp;
        [unew,lambdanew,iflag,iter]=...
            newton_ps(fun,jacob,utemp,params,jpar,t,[u1;lambda1],h,...
            TOL,TOL,maxit);
   if abs(iflag)>0
        disp('OH, CRANKY! NEWTON''S METHOD FAILED')
        disp('BEWARE OF ACCURACY OF COMPUTED BIFURCATION POINT')
        [mf,imf]=min([abs(f0),abs(f1)])
        if imf==1;
            unew=u0; lambdanew=lambda0; f=f0;
        else
            unew=u1; lambdanew=lambda1; f=f1;
        end
        break % break nos saca del ciclo donde estemos
    else
        u0=u1; x0=x1; lambda0=x0; u1=unew; x1=lambdanew; lambda1=x1;
        f0=f1; params(jpar)=lambda1; J=jacob(u1,params);
        e=eig(J); [me,ie]=min(abs(real(e))); f1=real(e(ie));
    end
  
end
disp(' ... done.')
disp(' ')
u=unew; lambda=lambdanew; params(jpar)=lambda;
J=jacob(u,params);
[V,D]=eig(J); e=diag(D); [me,ie]=min(abs(real(e)));
v=real(V(:,ie));
t=[v;0];
disp(strcat(['smallest real part of eigenvalue at computed bif. point = '...
          ,num2str(e(ie))]));
save(name_to_save_bif,'u','params','jpar','t');
disp(' ')
disp(strcat(['Results u params jpar and t stored on file',...
    blanks(3),name_to_save_bif,'.mat']))