function [f,fp]=fun_Euler(u,p)
% FUN_EULER returns in f minus the gradient of the potential
%     potential energy in bucklihg bars minus the lagrange
%     multiplier times the gradit of the restriction.
%  INPUT
%    u array of length N+1 with the angles
%        in U(1:N) and the Lagrange multiplier
%        in U(N+1)
%    p dimensionless force

N=length(u)-1; lambda=u(N+1); 
% lambda is the  Lagrange multipliear of the restriction
% 
%    sum from n=1 up to n=N sin(u_n)/N = 0
%
fd=[u(1)-u(2);-diff(diff(u(1:N))); u(N)-u(N-1)]*N;
sines=sin(u(1:N)); cosines=cos(u(1:N));
fs=(p/N)*sines-(lambda/N)*cosines;
f=[fd-fs; mean(sines)];

